#!/bin/bash

dir=$1
KLIST="1 2 3 4 5 6 7 8 9 10 25 50 75 100"

run_anonymization()
{
	FILES=$(find $dir -name "mondrian*.xml" -type f)
	
	K=$1
	for f in $FILES
	do
		touch ./tmpMondrian
		output="./tmpMondrian"
		ff=$(basename $f)
		fo=$(echo $ff | sed -r 's/mondrian_config_//')
		fo2=${fo%.*}
		dirName=${f%/*}
		levelUp=$(echo $dirName | sed -r 's/mondrian//')
		input=$levelUp""$fo2".csv"
		summary=$levelUp"summaries/"
		if [ ! -d $summary ]; then 
		  mkdir $summary
		fi
		(time java -cp toolbox_linux64/sqlite.jar:toolbox_linux64/anon_toolbox.jar:toolbox_linux64/. -Djava.library.path=toolbox_linux64/. anonymizer.Anonymizer -config $f -k $K -method Mondrian -output $output -input $input) 2> time.txt
		time=$(cat time.txt | awk '{print $2}' | awk 'NR==2')
		echo "starting evaluation..."
		./utils/preprocessMondrian tmpMondrian
		evalout=$(./utils/evaluateMondrian $input $output"2" False)
		echo $fo2" "$time" "$K" "$evalout  >> $summary"mondrian_"$fo2"_summary"
		echo "mondrian_"$fo2" "$time" "$K" "$evalout
		rm -rf ./tmpMondrian
		rm -rf ./tmpMondrian2
		rm -rf time.txt
	done
}

for k in $KLIST
do
	run_anonymization $k
done
