#!/bin/bash

dir=$1
KLIST="1 2 3 4 5 6 7 8 9 10 25 50 75 100"

FILES=$(find $dir -name "*.csv" -type f -and -not -path "*Patterns*" -and -not -path "*output*" -and -not -path "*summaries*")

for f in $FILES
do
	fff=${f%.csv}
	ff=${fff##*/}
	ddir=${f%/*}
	summaries=$ddir"/summaries/"
	if [ ! -d $summaries ]; then
	  mkdir $summaries
	fi
	if [ ! -d $ddir"/output" ]; then
	    mkdir $ddir"/output"
	fi
	PATTERNDIR=${f%.*}"Patterns"
	echo "file | time | k | #suppresions | #suppresions (weighted) | #eqClasses | useness | useness (weighted) | avg EqClass size | sum of squared EqClass size | max EqClass size | #columns | max no. of distinct elements | size of dataset" >> $summaries"pclustering_"$ff"_summary.csv"
	LOG=$ddir"/"$ff"_log.txt"
	for k in $KLIST
	do
		echo $ff >> $LOG
 		(time ./pclustering --k=$k $f --colTypes=$f".names") 1> prog_out.txt 2> time.txt
 		cat prog_out.txt >> $LOG

		time=$(cat time.txt | awk '{print $2}' | awk 'NR==2')
		echo "finished" $ff "for k="$k "after" $time

		outp=$(grep "#" prog_out.txt | cut -d "#" -f 2)
			
		echo $ff $outp >> $summaries"pclustering_"$ff"_summary.csv"
		echo "" >> $LOG
		mv output/* $ddir"/output/"

		if [ -e $PATTERNDIR ]; then
			patterns=$(find $PATTERNDIR -name "*.csv" -type f)
		    for pf in $patterns
		    do
		    	pp=$(basename $pf)
				pname="${pp%.*}"
		    	echo $ff $pname >> $LOG

		        (time ./pclustering --k=$k $f --p=$pf --colTypes=$f".names") 1> prog_out.txt 2> time.txt
		        cat prog_out.txt >> $LOG

				time=$(cat time.txt | awk '{print $2}' | awk 'NR==2')
				echo "finished" $ff "for k="$k "and pattern file " $pname " after" $time
				outputp="${ddir}/output/${ff}_k=${k}_${pname}.csv"
				outp=$(grep "#" prog_out.txt | cut -d "#" -f 2)
				mv "output/${ff}_k=${k}.csv" $outputp
				echo $ff $outp >> $summaries"pclustering_"$ff"_"$pname"_summary.csv"
				echo "" >> $LOG
		    done
		fi
	done
done
rm -rf output
rm -rf time.txt
rm -rf prog_out.txt