{-# LANGUAGE BangPatterns #-}
{-# LANGUAGE OverloadedStrings #-}

import System.IO
import System.Environment (getArgs)
import Data.List
import qualified Data.Text.Lazy as T
import qualified Data.Text.Lazy.IO as TIO
import qualified Data.Map as M

parseField :: T.Text -> M.Map T.Text Int -> (M.Map T.Text Int,T.Text)
parseField str mmap = let x :: [T.Text]
                          x = T.split (== '#') str
                          next = if length x == 3
                                 then res x
                                 else (mmap,str)
                          !nkey = M.size mmap
                          res (_:s:ss:[]) = case M.lookup ss mmap of
                                        Nothing -> (M.insert ss nkey mmap,T.pack "#" `T.append` s `T.append` "#" `T.append` T.pack "a" `T.append` T.pack (show nkey))
                                        Just k -> (mmap, T.pack "#" `T.append` s `T.append` "#" `T.append` T.pack "a" `T.append` T.pack (show k))
                      in next

writeFile2 :: T.Text -> FilePath -> IO ()
writeFile2 x f = do
                     handle <- openFile f WriteMode
                     go handle (T.lines x) M.empty
                     hClose handle
            where
              go :: Handle -> [T.Text] -> M.Map T.Text Int -> IO ()
              go _ [] _ = return ()
              go h (x:xs) mmap = let (nmap,inp) = mapAccumL (\(!mapping) (!inp) -> parseField inp mapping) mmap (T.split (== ',') x)
                                 in do
                                      TIO.hPutStrLn h (T.concat $ intersperse (T.pack ",") inp)
                                      go h xs nmap


main :: IO ()
main = do
    (file:_) <- getArgs
    inp <- TIO.readFile file
    writeFile2 inp (file++"2")